﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json;

namespace BulkSMSAPI
{
    class Program
    {
        public static string apiurl = "http://www.smspins.com/pins/apiv2/";
        public static string apikey = "_YOUR_API_KEY_HERE_";

        static async Task BulkSMSRequest(int telephone_id)
        {
            Client client = new Client(apiurl,apikey);
            RequestResponse resRequest = await client.Request(telephone_id);
            Console.WriteLine(resRequest.success);
            if (resRequest.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine(resRequest.data.request_id);
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resRequest.message);
            }
            Console.ReadLine();
        }
        
        static async Task BulkSMSTelephones()
        {
            Client client = new Client(apiurl, apikey);
            TelephonesResponse resTelephones = await client.Telephones();
            Console.WriteLine(resTelephones.success);
            if (resTelephones.success == true)
            {
                // Status Detail
                foreach (TelephonesData telephone in resTelephones.data)
                {
                    Console.WriteLine(telephone.telephone_id);
                    Console.WriteLine(telephone.telephone);
                    Console.WriteLine(telephone.added_at);
                    Console.WriteLine(telephone.expired_at);
                }
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resTelephones.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSStatus(int request_id)
        {
            Client client = new Client(apiurl,apikey);
            StatusResponse resStatus = await client.Status(request_id);
            Console.WriteLine(resStatus.success);
            if (resStatus.success == true)
            {
                // Status Detail
                Console.WriteLine(resStatus.data.request_id);
                Console.WriteLine(resStatus.data.agent_name);//Which Agent is serving your request
                Console.WriteLine(resStatus.data.telephone);
                Console.WriteLine(resStatus.data.smses);
                Console.WriteLine(resStatus.data.status);
                Console.WriteLine(resStatus.data.started_at); // The time Agent has started processing the request
                Console.WriteLine(resStatus.data.ended_at); // The time system finished processing this request
                Console.WriteLine(resStatus.data.acquired_at);// The time Agent has acquired for processing
                Console.WriteLine(resStatus.data.queued_at); // The time client created the request
                Console.WriteLine(resStatus.data.canceled_at); // The time when request is canceled
                Console.WriteLine(resStatus.data.updated_at); // The time request has last status update
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resStatus.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSRequests()
        {
            Client client = new Client(apiurl, apikey);
            RequestsResponse resRequests = await client.Requests();
            Console.WriteLine(resRequests.success);
            if (resRequests.success == true)
            {
                // Status Detail
                foreach(RequestsData request in resRequests.data)
                {
                    Console.WriteLine(request.request_id);
                    Console.WriteLine(request.status);
                    Console.WriteLine(request.telephone);
                    Console.WriteLine(request.queued_at);
                    Console.WriteLine(request.updated_at);
                }
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resRequests.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSSMSesByTID(int telephone_id)
        {
            Client client = new Client(apiurl, apikey);
            SMSesByTIDResponse resSMSes = await client.SMSesByTID(telephone_id);
            Console.WriteLine(resSMSes.success);
            if (resSMSes.success == true)
            {
                // Status Detail
                foreach (SMSesByTIDData request in resSMSes.data)
                {
                    Console.WriteLine(request.telephone_id);
                    Console.WriteLine(request.request_id);
                    Console.WriteLine(request.smses);
                    Console.WriteLine(request.telephone);
                    Console.WriteLine(request.updated_at);
                }
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resSMSes.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSCancel(int request_id)
        {
            Client client = new Client(apiurl, apikey);
            CancelResponse resCancel = await client.Cancel(request_id);
            Console.WriteLine(resCancel.success);
            if (resCancel.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine(resCancel.data.request_id);
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resCancel.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSAutocheckEnable(int telephone_id)
        {
            Client client = new Client(apiurl, apikey);
            AutocheckResponse resAutocheck = await client.EnableAutocheck(telephone_id);
            Console.WriteLine(resAutocheck.success);
            if (resAutocheck.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine("SMS Auto Check Enabled");
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resAutocheck.message);
            }
            Console.ReadLine();
        }
        static async Task BulkSMSAutocheckDisable(int telephone_id)
        {
            Client client = new Client(apiurl, apikey);
            AutocheckResponse resAutocheck = await client.DisableAutocheck(telephone_id);
            Console.WriteLine(resAutocheck.success);
            if (resAutocheck.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine("SMS Auto Check Disabled");
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resAutocheck.message);
            }
            Console.ReadLine();
        }
        static async Task NCRequest(int telephone_id, string zip)
        {
            Client client = new Client(apiurl, apikey);
            NCRequestResponse resRequest = await client.NCRequest(telephone_id, zip);
            Console.WriteLine(resRequest.success);
            if (resRequest.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine(resRequest.data.request_id);
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resRequest.message);
            }
            Console.ReadLine();
        }
        static async Task NCStatus(int request_id)
        {
            Client client = new Client(apiurl, apikey);
            NCStatusResponse resStatus = await client.NCStatus(request_id);
            Console.WriteLine(resStatus.success);
            if (resStatus.success == true)
            {
                // Status Detail
                Console.WriteLine(resStatus.data.request_id);
                Console.WriteLine(resStatus.data.agent_name);//Which Agent is serving your request
                Console.WriteLine(resStatus.data.last_telephone);
                Console.WriteLine(resStatus.data.telephone);
                Console.WriteLine(resStatus.data.status);
                Console.WriteLine(resStatus.data.submitted_at); // The time client created the request
                Console.WriteLine(resStatus.data.acquired_at);// The time Agent has acquired for processing
                Console.WriteLine(resStatus.data.processed_at);// The time when Agent start processing
                Console.WriteLine(resStatus.data.completed_at);// The time when Agent finished processing
                Console.WriteLine(resStatus.data.canceled_at); // The time when request is canceled
                Console.WriteLine(resStatus.data.updated_at); // The time request has last status update
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resStatus.message);
            }
            Console.ReadLine();
        }
        static async Task NCRequests()
        {
            Client client = new Client(apiurl, apikey);
            NCRequestsResponse resRequests = await client.NCRequests();
            Console.WriteLine(resRequests.success);
            if (resRequests.success == true)
            {
                // Status Detail
                foreach (NCRequestsData request in resRequests.data)
                {
                    Console.WriteLine(request.request_id);
                    Console.WriteLine(request.status);
                    Console.WriteLine(request.last_telephone);
                    Console.WriteLine(request.telephone);
                    Console.WriteLine(request.submitted_at);
                    Console.WriteLine(request.canceled_at);
                    Console.WriteLine(request.updated_at);
                }
            }
            else
            {
                // Unable to get status
                Console.WriteLine(resRequests.message);
            }
            Console.ReadLine();
        }
        static async Task NCCancel(int request_id)
        {
            Client client = new Client(apiurl, apikey);
            NCCancelResponse resCancel = await client.NCCancel(request_id);
            Console.WriteLine(resCancel.success);
            if (resCancel.success == true)
            {
                // Request is submitted and request id is returned
                Console.WriteLine(resCancel.data.request_id);
            }
            else
            {
                // Unable to submit request
                Console.WriteLine(resCancel.message);
            }
            Console.ReadLine();
        }
        static void Main(string[] args)
        {
            //BulkSMSRequest(4774).GetAwaiter().GetResult();
            //BulkSMSStatus(14772).GetAwaiter().GetResult();
            //BulkSMSRequests().GetAwaiter().GetResult();
            //BulkSMSCancel(14772).GetAwaiter().GetResult();
            //BulkSMSAutocheckEnable(4774).GetAwaiter().GetResult();
            //BulkSMSAutocheckDisable(4774).GetAwaiter().GetResult();
            //BulkSMSTelephones().GetAwaiter().GetResult();
            BulkSMSSMSesByTID(1).GetAwaiter().GetResult();

            //NCRequest(4774, "11432").GetAwaiter().GetResult();
            //NCStatus(36).GetAwaiter().GetResult();
            //NCRequests().GetAwaiter().GetResult();
            //NCCancel(36).GetAwaiter().GetResult();

            Console.ReadLine();
        }
    }
}

